wxWidgets: /home/Hamis/wxwidgets/wxWidgets3.0/wxWidgets3.0-3.0.5.1-2.x86_64/src/wxWidgets-3.0.5.1/interface/wx/translation.h File Reference

| Version: 3.0.5

Classes | Macros | Functions
translation.h File Reference

## Classes
class | wxTranslations
| This class allows getting translations for strings. More...
class | wxTranslationsLoader
| Abstraction of translations discovery and loading. More...
class | wxFileTranslationsLoader
| Standard wxTranslationsLoader implementation. More...
class | wxResourceTranslationsLoader
| This loader makes it possible to load translations from Windows resources. More...
class | wxMsgCatalog
| Represents a loaded translations message catalog. More...

## Macros
#define | wxPLURAL(string, plural, n)
| This macro is identical to _() but for the plural variant of wxGetTranslation(). More...
#define | wxTRANSLATE(string)
| This macro doesn't do anything in the program code – it simply expands to the value of its argument. More...

## Functions
const wxString & | wxGetTranslation (const wxString &string, const wxString &domain=wxEmptyString)
| This function returns the translation of string in the current `locale()`. More...
const wxString & | wxGetTranslation (const wxString &string, const wxString &plural, unsigned n, const wxString &domain=wxEmptyString)
| This is an overloaded version of wxGetTranslation(const wxString&, const wxString&), please see its documentation for general information. More...
const wxString & | _ (const wxString &string)
| Macro to be used around all literal strings that should be translated. More...

## Macro Definition Documentation

## ◆ wxPLURAL

#define wxPLURAL | ( |  | string,
|  |  | plural,
|  |  | n
| ) |  |

This macro is identical to _() but for the plural variant of wxGetTranslation().

Returns
  A const wxString.

Include file:

    #include <wx/intl.h>

## ◆ wxTRANSLATE

#define wxTRANSLATE | ( |  | string | ) |

This macro doesn't do anything in the program code – it simply expands to the value of its argument.

However it does have a purpose which is to mark the literal strings for the extraction into the message catalog created by `xgettext` program. Usually this is achieved using _() but that macro not only marks the string for extraction but also expands into a wxGetTranslation() call which means that it cannot be used in some situations, notably for static array initialization.

Here is an example which should make it more clear: suppose that you have a static array of strings containing the weekday names and which have to be translated (note that it is a bad example, really, as wxDateTime already can be used to get the localized week day names already). If you write:

static const char * const weekdays[] = { _("Mon"), ..., _("Sun") };
...
// use weekdays[n] as usual
_
const wxString & _(const wxString &string)
Macro to be used around all literal strings that should be translated.

The code wouldn't compile because the function calls are forbidden in the array initializer. So instead you should do this:

static const char * const weekdays[] = { wxTRANSLATE("Mon"), ...,
wxTRANSLATE("Sun") };
...
// use wxGetTranslation(weekdays[n])
wxTRANSLATE
#define wxTRANSLATE(string)
This macro doesn't do anything in the program code – it simply expands to the value of its argument.
Definition: translation.h:507

Note that although the code would compile if you simply omit wxTRANSLATE() in the above, it wouldn't work as expected because there would be no translations for the weekday names in the program message catalog and wxGetTranslation() wouldn't find them.

Returns
  A const wxChar*.

Include file:

    #include <wx/intl.h>

## Function Documentation

## ◆ _()

const wxString& _ | ( | const wxString & | string | ) |

Macro to be used around all literal strings that should be translated.

This macro expands into a call to wxGetTranslation(), so it marks the message for the extraction by `xgettext` just as wxTRANSLATE() does, but also returns the translation of the string for the current locale during execution.

This macro is thread-safe.

Include file:

    #include <wx/intl.h>

## ◆ wxGetTranslation() [1/2]

const wxString& wxGetTranslation | ( | const wxString & | string,
|  | const wxString & | domain = `wxEmptyString`
| ) |  |

This function returns the translation of string in the current `locale()`.

If the string is not found in any of the loaded message catalogs (see Internationalization), the original string is returned. In debug build, an error message is logged – this should help to find the strings which were not yet translated. If domain is specified then only that domain/catalog is searched for a matching string. As this function is used very often, an alternative (and also common in Unix world) syntax is provided: the _() macro is defined to do the same thing as wxGetTranslation().

This function is thread-safe.

Note
  This function is not suitable for literal strings in Unicode builds since the literal strings must be enclosed in wxT() macro which makes them unrecognised by `xgettext`, and so they are not extracted to the message catalog. Instead, use the _() and wxPLURAL() macro for all literal strings.

See also
  wxGetTranslation(const wxString&, const wxString&, unsigned, const wxString&)

Include file:

    #include <wx/intl.h>

## ◆ wxGetTranslation() [2/2]

const wxString& wxGetTranslation | ( | const wxString & | string,
|  | const wxString & | plural,
|  | unsigned | n,
|  | const wxString & | domain = `wxEmptyString`
| ) |  |

This is an overloaded version of wxGetTranslation(const wxString&, const wxString&), please see its documentation for general information.

This version is used when retrieving translation of string that has different singular and plural forms in English or different plural forms in some other language. Like wxGetTranslation(const wxString&,const wxString&), the string parameter must contain the singular form of the string to be converted and is used as the key for the search in the catalog. The plural parameter is the plural form (in English). The parameter n is used to determine the plural form. If no message catalog is found, string is returned if "n == 1", otherwise plural is returned.

See GNU gettext Manual for additional information on plural forms handling: http://www.gnu.org/software/gettext/manual/gettext.html#Plural-forms For a shorter alternative see the wxPLURAL() macro.

This function is thread-safe.

Include file:

    #include <wx/intl.h>